unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  F             : TFileStream   ; //  t@CXg[
  ML            : TMemoryStream ; //  [hpXg[
  MS            : TMemoryStream ; //  Z[upXg[
  LFPFN         : String        ; //  [ht@Cl[itpXj
  LFN           : String        ; //  [ht@Cl[
  SFPFN         : String        ; //  Z[ut@Cl[itpXj
  SFN           : String        ; //  Z[ut@Cl[
  FRead1BB      : Byte          ; //  PoCg̃f[^[hƗpϐ
  HeaderCheck   : String        ; //  wb_i[pϐ
  hc            : Byte          ; //  wb_JE^
  HeaderHit     : Byte          ; //  wb_tO
  SearchCounter : Byte          ; //  wb_擪qbg

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ML := TMemoryStream.Create ; //  [hpXg[
  MS := TMemoryStream.Create ; //  Z[upXg[
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ML.Free ; //  [hpXg[j
  MS.Free ; //  Z[upXg[j
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenDialog1.FileName := '*.rps' ;
  if OpenDialog1.Execute then
    begin
      LFPFN := OpenDialog1.FileName ;              //  [ht@Cl[擾itpXj
      LFN := ExtractFileName(LFPFN) ;              //  [ht@Cl[擾
      F := TFileStream.Create(LFPFN, fmOpenRead) ; //  t@CXg[
      ML.SetSize(F.Size) ;                         //  t@CTCY[hm
      F.Free ;                                     //  t@CXg[j
      ML.LoadFromFile(LFPFN) ;                     //  t@C[hɃ[h
      Memo1.Lines.Add(IntToStr(ML.Size) + ' Byte') ;
      Label2.Caption := LFN ;                      //  [ht@Cl[\
    end else begin
      Exit ;
    end ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SaveDialog1.FileName := ChangeFileExt( LFN, '.rns') ; //  gq *.rns ɕύX
  HeaderHit  := 0 ; //  wb_tO
  if SaveDialog1.Execute then
    begin
      SFPFN := SaveDialog1.FileName ; //  Z[ut@Cl[擾itpXj
      SFN := ExtractFileName(SFPFN) ; //  Z[ut@Cl[擾
      ML.Position := 0 ;              //  [hgbvɃZbg
      SearchCounter := 1 ;
      while HeaderHit = 0 do          //  wb_擪܂ŒT[v
        begin
          Memo1.Lines.Add('Search ' + IntToStr(SearchCounter)) ;
          if ML.Size = ML.Position then Break ; //  [h̏IȂ烋[vI
          FRead1BB := 0 ; //  Ɨpϐ̏
          if (IntToHex(FRead1BB, 2)) <> '50' then
            begin
              while (IntToHex(FRead1BB, 2)) <> '50' do //  wb_̐擪܂
                ML.Read(FRead1BB, Sizeof(FRead1BB)) ;  //  PoCgǂݍ
            end ;
          Memo1.Lines.Add('Hit') ;
          HeaderCheck := IntToHex(FRead1BB, 2) ; //  wb_̐擪i[
          hc := 0 ; //  JE^
          while hc < 31 do
            begin
              if ML.Size = ML.Position then Break ;                //  [h̏IȂ烋[vI
              ML.Read(FRead1BB, Sizeof(FRead1BB)) ;                //  PoCgǂݍ
              HeaderCheck := HeaderCheck + IntToHex(FRead1BB, 2) ; //  ǉi[
              hc := hc + 1 ;
              Memo1.Lines.Clear ;
              Memo1.Lines.Add(IntToStr(ML.Position)) ;
            end ;
          if ML.Size = ML.Position then Break ; //  [h̏IȂ烋[vI
          if HeaderCheck = '50726F70656C6C6572686561647320526561736F6E20536F6E672046696C651A' then
            begin
              HeaderHit := 1 ;                    //  wb_tO𗧂Ă
              ML.Seek(-32, 1) ;                   //  [hwb_̐擪ɃZbg
              MS.SetSize(ML.Size - ML.Position) ; //  f[^TCYZ[um
              Memo1.Lines.Clear ;
              Memo1.Lines.Add('Bingo') ;
            end else
            begin
              ML.Seek(-31, 1) ;
              Memo1.Lines.Clear ;
              Memo1.Lines.Add('No Match') ;
            end ;
          SearchCounter := SearchCounter + 1 ;
        end ;
      if HeaderHit = 1 then
        begin
          MS.Position := 0 ;         //  Z[ugbvɃZbg
          MS.CopyFrom(ML, MS.Size) ; //  Z[uɃ[h̃wb_ȍ~Rs[
          Memo1.Lines.Clear ;
          Memo1.Lines.Add('Copy') ;
          MS.SaveToFile(SFPFN) ;     // Z[ut@CɃZ[u
          Memo1.Lines.Clear ;
          Memo1.Lines.Add('Convert completed successfully!') ;
          Memo1.Lines.Add('LoopTheory') ;
          Memo1.Lines.Add('http://www.looptheory.com/') ;
          Label2.Caption := SFN ;    // Z[ut@Cl[\
        end ;
    end else begin
      Exit ;
    end ;
end;

end.

